/* Verilog Model Created from SCS Schematic conv22.sch 
   May 14, 2005 22:01 */

/* Automatically generated by hvveri version 8.2  */

`timescale 1ns/1ns  
`define LOGIC   1 
`define BIDIR   2 
`define INCELL  3 
`define CLOCK   4 
`define HSCK    5 
`define CLOCKB  6 
`define ESPXCLKIN  7 

module conv22( clk, clr, d1d, d2d, F2OUT, ld, ven1, ven2 );
input clk, clr;
 input [15:0] d1d;
 input [15:0] d2d;
output F2OUT;
input ld, ven1, ven2;
wire [15:0] d2;
wire [15:0] d1;
wire [25:0] t1;
wire [24:0] f1;
wire [16:0] c1;
wire [25:0] t2;
wire [24:0] f2;
wire [16:0] c2;
wire iclr;
wire iclk;
wire N_1;
wire N_2;
wire N_3;
wire t1co;
wire N_4;
wire N_5;
wire N_6;
wire N_7;
wire N_8;
wire N_9;

inpad I81 ( .P(ld), .Q(N_5) );
ipad16 I80 ( .P({ d2d[15:0] }), .Q({ d2[15:0] }) );
ipad16 I79 ( .P({ d1d[15:0] }), .Q({ d1[15:0] }) );
and2i1 I76 ( .A(N_8), .B(N_6), .Q(N_4) );
acc26r I70 ( .clk(iclk), .clr(iclr), .co(N_3), .e({ t2[25:0] }), .q({ f2[24:0] }) );
acc26r I64 ( .clk(iclk), .clr(iclr), .co(t1co), .e({ t1[25:0] }),
          .q({ f1[24:0] }) );
mux26 I71 ( .a({ d2[15:0] }), .b({ c2[16:0] }), .sel(N_3), .st(N_1), .ven(N_2),
         .y({ f2[24:0] }) );
mux26 I_63 ( .a({ d1[15:0] }), .b({ c1[16:0] }), .sel(t1co), .st(N_7), .ven(N_9),
          .y({ f1[24:0] }) );
ckpad I_61 ( .P(clk), .Q(iclk) );
hdpad I72 ( .P(ven2), .Q(N_2) );
hdpad I_58 ( .P(ven1), .Q(N_9) );
hdipad I_45 ( .P(clr), .Q(iclr) );
dff I82 ( .CLK(iclk), .D(N_5), .Q(N_8) );
dff I77 ( .CLK(iclk), .D(N_8), .Q(N_6) );
outpad I_28 ( .A(t2[25]), .P(F2OUT) );
upct17c I73 ( .CLK(iclk), .CLR(iclr), .LOAD(t1co), .st(N_1), .Y({ c2[16:0] }) );
upct17c I_4 ( .CLK(iclk), .CLR(iclr), .LOAD(N_4), .st(N_7), .Y({ c1[16:0] }) );

endmodule // conv22


`ifdef inpad
`else
`define inpad
module inpad( P, Q );
input P;
output Q;
parameter ql_gate = `BIDIR;
supply1 VCC;
supply0 GND;

bicell QL1 ( .I1(GND), .I2(VCC), .IE(GND), .IP(P), .IZ(Q) );

endmodule // inpad

`endif

`ifdef ipad16
`else
`define ipad16
module ipad16( P, Q );
 input [15:0] P;
 output [15:0] Q;

inpad QL1 ( .P(P[15]), .Q(Q[15]) );
inpad QL2 ( .P(P[12]), .Q(Q[12]) );
inpad QL3 ( .P(P[13]), .Q(Q[13]) );
inpad QL4 ( .P(P[14]), .Q(Q[14]) );
inpad QL5 ( .P(P[11]), .Q(Q[11]) );
inpad QL6 ( .P(P[10]), .Q(Q[10]) );
inpad QL7 ( .P(P[9]), .Q(Q[9]) );
inpad QL8 ( .P(P[8]), .Q(Q[8]) );
inpad QL9 ( .P(P[4]), .Q(Q[4]) );
inpad QL10 ( .P(P[5]), .Q(Q[5]) );
inpad QL11 ( .P(P[6]), .Q(Q[6]) );
inpad QL12 ( .P(P[7]), .Q(Q[7]) );
inpad QL13 ( .P(P[0]), .Q(Q[0]) );
inpad QL14 ( .P(P[1]), .Q(Q[1]) );
inpad QL15 ( .P(P[2]), .Q(Q[2]) );
inpad QL16 ( .P(P[3]), .Q(Q[3]) );

endmodule // ipad16

`endif

`ifdef and2i1
`else
`define and2i1
module and2i1( A, B, Q );
input A, B;
output Q;
parameter ql_gate = `LOGIC;
supply1 VCC;
supply0 GND;

frag_a QL1 ( .A1(A), .A2(GND), .A3(VCC), .A4(GND), .A5(VCC), .A6(B), .AZ(Q) );

endmodule // and2i1

`endif

`ifdef acc26r
`else
`define acc26r
module acc26r( clk, clr, co, e, q );
input clk, clr;
output co;
 output [25:0] e;
 input [24:0] q;
wire [23:0] a;
supply0 gnd;
wire N_1;
wire N_2;
wire N_3;
wire N_4;

radd8 I283 ( .A({ q[23:16] }), .B({ e[23:16] }), .CI(N_2), .CO(N_3),
          .S({ a[23:16] }) );
radd16 I284 ( .A({ q[15:0] }), .B({ e[15:0] }), .CI(gnd), .CO(N_2),
           .S({ a[15:0] }) );
rgc8 I279 ( .CLK(clk), .CLR(clr), .D({ a[23:16] }), .Q({ e[23:16] }) );
rgc16 I282 ( .CLK(clk), .CLR(clr), .D({ a[15:0] }), .Q({ e[15:0] }) );
tffpc I273 ( .CLK(clk), .CLR(clr), .PRE(gnd), .Q(e[25]), .T(N_4) );
dffc I274 ( .CLK(clk), .CLR(clr), .D(N_1), .Q(e[24]) );
dff I_241 ( .CLK(clk), .D(N_4), .Q(co) );
fadd1 I_253 ( .A(q[24]), .B(e[24]), .CI(N_3), .CO(N_4), .S(N_1) );

endmodule // acc26r

`endif

`ifdef mux26
`else
`define mux26
module mux26( a, b, sel, st, ven, y );
 input [24:9] a;
 input [16:0] b;
input sel, st, ven;
 output [24:0] y;
wire a2y;
wire N_1;
supply0 gnd;

and2i0 I58 ( .A(sel), .B(ven), .Q(N_1) );
or2i0 I59 ( .A(st), .B(N_1), .Q(a2y) );
mux2x0 I_54 ( .A(b[7]), .B(gnd), .Q(y[7]), .S(a2y) );
mux2x0 I_55 ( .A(b[6]), .B(gnd), .Q(y[6]), .S(a2y) );
mux2x0 I_56 ( .A(b[5]), .B(gnd), .Q(y[5]), .S(a2y) );
mux2x0 I_57 ( .A(b[4]), .B(gnd), .Q(y[4]), .S(a2y) );
mux2x0 I_58 ( .A(b[3]), .B(gnd), .Q(y[3]), .S(a2y) );
mux2x0 I_59 ( .A(b[2]), .B(gnd), .Q(y[2]), .S(a2y) );
mux2x0 I_60 ( .A(b[1]), .B(gnd), .Q(y[1]), .S(a2y) );
mux2x0 I_61 ( .A(b[0]), .B(gnd), .Q(y[0]), .S(a2y) );
mux2x0 I_46 ( .A(b[15]), .B(a[15]), .Q(y[15]), .S(a2y) );
mux2x0 I_47 ( .A(b[14]), .B(a[14]), .Q(y[14]), .S(a2y) );
mux2x0 I_48 ( .A(b[13]), .B(a[13]), .Q(y[13]), .S(a2y) );
mux2x0 I_49 ( .A(b[12]), .B(a[12]), .Q(y[12]), .S(a2y) );
mux2x0 I_50 ( .A(b[11]), .B(a[11]), .Q(y[11]), .S(a2y) );
mux2x0 I_51 ( .A(b[10]), .B(a[10]), .Q(y[10]), .S(a2y) );
mux2x0 I_52 ( .A(b[9]), .B(a[9]), .Q(y[9]), .S(a2y) );
mux2x0 I_53 ( .A(b[8]), .B(gnd), .Q(y[8]), .S(a2y) );
mux2x0 I_37 ( .A(gnd), .B(a[24]), .Q(y[24]), .S(a2y) );
mux2x0 I_38 ( .A(gnd), .B(a[23]), .Q(y[23]), .S(a2y) );
mux2x0 I_39 ( .A(gnd), .B(a[22]), .Q(y[22]), .S(a2y) );
mux2x0 I_40 ( .A(gnd), .B(a[21]), .Q(y[21]), .S(a2y) );
mux2x0 I_41 ( .A(gnd), .B(a[20]), .Q(y[20]), .S(a2y) );
mux2x0 I_42 ( .A(gnd), .B(a[19]), .Q(y[19]), .S(a2y) );
mux2x0 I_43 ( .A(gnd), .B(a[18]), .Q(y[18]), .S(a2y) );
mux2x0 I_44 ( .A(gnd), .B(a[17]), .Q(y[17]), .S(a2y) );
mux2x0 I_45 ( .A(b[16]), .B(a[16]), .Q(y[16]), .S(a2y) );

endmodule // mux26

`endif

`ifdef ckpad
`else
`define ckpad
module ckpad( P, Q );
input P;
output Q;
parameter ql_gate = `CLOCK;

ckcell QL1 ( .IC(Q), .IP(P) );

endmodule // ckpad

`endif

`ifdef hdpad
`else
`define hdpad
module hdpad( P, Q );
input P;
output Q;
parameter ql_gate = `INCELL;

incell QL1 ( .IP(P), .IZ(Q) );

endmodule // hdpad

`endif

`ifdef hdipad
`else
`define hdipad
module hdipad( P, Q );
input P;
output Q;
parameter ql_gate = `INCELL;

incell QL1 ( .IN(Q), .IP(P) );

endmodule // hdipad

`endif

`ifdef dff
`else
`define dff
module dff( CLK, D, Q );
input CLK, D;
output Q;
parameter ql_gate = `LOGIC;
supply0 GND;
wire N_1;
supply1 VCC;
wire N_2;
wire N_3;

frag_m I_3 ( .B1(VCC), .B2(GND), .C1(VCC), .C2(GND), .D1(VCC), .D2(GND), .E1(D),
          .E2(GND), .NS(N_2), .OS(N_3), .OZ(N_1) );
frag_q I_2 ( .QC(CLK), .QD(N_1), .QR(GND), .QS(GND), .QZ(Q) );
frag_a I_1 ( .A1(VCC), .A2(GND), .A3(VCC), .A4(GND), .A5(VCC), .A6(GND), .AZ(N_3) );
frag_f QL1 ( .F1(VCC), .F2(GND), .F3(VCC), .F4(GND), .F5(VCC), .F6(GND), .FZ(N_2) );

endmodule // dff

`endif

`ifdef outpad
`else
`define outpad
module outpad( A, P );
input A;
output P;
parameter ql_gate = `BIDIR;
supply1 VCC;

bicell QL1 ( .I1(VCC), .I2(A), .IE(VCC), .IP(P) );

endmodule // outpad

`endif

`ifdef upct17c
`else
`define upct17c
module upct17c( CLK, CLR, LOAD, st, Y );
input CLK, CLR, LOAD;
output st;
 output [16:0] Y;
wire [16:0] Q;
wire N_8;
wire N_9;
wire N_7;
supply1 vcc;
supply0 GND;
wire N_3;
wire N_4;
wire N_5;
wire N_6;

rgec16 I143 ( .CLK(CLK), .CLR(N_9), .D({ Q[15:0] }), .EN(LOAD), .Q({ Y[15:0] }) );
and4i0 I142 ( .A(Q[13]), .B(Q[14]), .C(Q[15]), .D(Q[16]), .Q(N_7) );
dffepc I_127 ( .CLK(CLK), .CLR(N_9), .D(Q[16]), .EN(LOAD), .PRE(GND), .Q(Y[16]) );
and2i1 I144 ( .A(N_8), .B(N_9), .Q(st) );
dff I145 ( .CLK(CLK), .D(N_9), .Q(N_8) );
dff I_126 ( .CLK(CLK), .D(N_7), .Q(N_9) );
nand5i1 I_49 ( .A(Q[7]), .B(Q[6]), .C(Q[5]), .D(Q[4]), .E(N_3), .Q(N_4) );
nand5i1 I_48 ( .A(Q[8]), .B(Q[9]), .C(Q[10]), .D(Q[11]), .E(N_4), .Q(N_5) );
nand4i0 I_50 ( .A(Q[0]), .B(Q[1]), .C(Q[2]), .D(Q[3]), .Q(N_3) );
and2i0 I_46 ( .A(Q[14]), .B(Q[15]), .Q(N_6) );
upbit I_16 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(GND), .ENT(GND),
          .LOAD(LOAD), .Q(Q[2]), .Q0(Q[0]), .Q1(Q[1]), .Q2(vcc) );
upbit I_17 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(GND), .ENT(GND),
          .LOAD(LOAD), .Q(Q[3]), .Q0(Q[0]), .Q1(Q[1]), .Q2(Q[2]) );
upbit I_15 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(GND), .ENT(GND),
          .LOAD(LOAD), .Q(Q[0]), .Q0(vcc), .Q1(vcc), .Q2(vcc) );
upbit I_18 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(GND), .ENT(GND),
          .LOAD(LOAD), .Q(Q[1]), .Q0(Q[0]), .Q1(vcc), .Q2(vcc) );
upbit I_31 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(N_3), .ENT(GND),
          .LOAD(LOAD), .Q(Q[6]), .Q0(Q[4]), .Q1(Q[5]), .Q2(vcc) );
upbit I_32 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(N_3), .ENT(GND),
          .LOAD(LOAD), .Q(Q[7]), .Q0(Q[4]), .Q1(Q[5]), .Q2(Q[6]) );
upbit I_29 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(N_3), .ENT(GND),
          .LOAD(LOAD), .Q(Q[4]), .Q0(vcc), .Q1(vcc), .Q2(vcc) );
upbit I_30 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(N_3), .ENT(GND),
          .LOAD(LOAD), .Q(Q[5]), .Q0(Q[4]), .Q1(vcc), .Q2(vcc) );
upbit I_41 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(N_5), .ENT(GND),
          .LOAD(LOAD), .Q(Q[16]), .Q0(Q[12]), .Q1(Q[13]), .Q2(N_6) );
upbit I_35 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(N_5), .ENT(GND),
          .LOAD(LOAD), .Q(Q[14]), .Q0(Q[12]), .Q1(Q[13]), .Q2(vcc) );
upbit I_36 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(N_5), .ENT(GND),
          .LOAD(LOAD), .Q(Q[15]), .Q0(Q[12]), .Q1(Q[13]), .Q2(Q[14]) );
upbit I_39 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(N_4), .ENT(GND),
          .LOAD(LOAD), .Q(Q[10]), .Q0(Q[8]), .Q1(Q[9]), .Q2(vcc) );
upbit I_40 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(N_4), .ENT(GND),
          .LOAD(LOAD), .Q(Q[11]), .Q0(Q[8]), .Q1(Q[9]), .Q2(Q[10]) );
upbit I_37 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(N_4), .ENT(GND),
          .LOAD(LOAD), .Q(Q[8]), .Q0(vcc), .Q1(vcc), .Q2(vcc) );
upbit I_38 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(N_4), .ENT(GND),
          .LOAD(LOAD), .Q(Q[9]), .Q0(Q[8]), .Q1(vcc), .Q2(vcc) );
upbit I_33 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(N_5), .ENT(GND),
          .LOAD(LOAD), .Q(Q[12]), .Q0(vcc), .Q1(vcc), .Q2(vcc) );
upbit I_34 ( .CLK(CLK), .CLR(CLR), .D(GND), .ENG(GND), .ENP(N_5), .ENT(GND),
          .LOAD(LOAD), .Q(Q[13]), .Q0(Q[12]), .Q1(vcc), .Q2(vcc) );

endmodule // upct17c

`endif

`ifdef bicell
`else
`define bicell
module bicell( I1, I2, IE, IP, IZ );
input I1, I2, IE;
inout IP;
output IZ;
parameter ql_frag = 1;
 assign #1 IP = IE ? (~I1 | I2):1'bz;
 assign #1 IZ = IP;

endmodule // bicell

`endif

`ifdef frag_a
`else
`define frag_a
module frag_a( A1, A2, A3, A4, A5, A6, AZ );
input A1, A2, A3, A4, A5, A6;
output AZ;
parameter ql_frag = 1;
 assign #1 AZ = A1 & ~A2 & A3 & ~A4 & A5 & ~A6;

endmodule // frag_a

`endif

`ifdef radd8
`else
`define radd8
module radd8( A, B, CI, CO, S );
 input [7:0] A;
 input [7:0] B;
input CI;
output CO;
 output [7:0] S;
wire N_1;

radd4 QL2 ( .A({ A[7:4] }), .B({ B[7:4] }), .CI(N_1), .CO(CO), .S({ S[7:4] }) );
radd4 QL1 ( .A({ A[3:0] }), .B({ B[3:0] }), .CI(CI), .CO(N_1), .S({ S[3:0] }) );

endmodule // radd8

`endif

`ifdef radd16
`else
`define radd16
module radd16( A, B, CI, CO, S );
 input [15:0] A;
 input [15:0] B;
input CI;
output CO;
 output [15:0] S;
wire N_1;
wire N_2;
wire N_3;

radd4 QL4 ( .A({ A[15:12] }), .B({ B[15:12] }), .CI(N_1), .CO(CO),
         .S({ S[15:12] }) );
radd4 QL3 ( .A({ A[11:8] }), .B({ B[11:8] }), .CI(N_2), .CO(N_1), .S({ S[11:8] }) );
radd4 QL2 ( .A({ A[7:4] }), .B({ B[7:4] }), .CI(N_3), .CO(N_2), .S({ S[7:4] }) );
radd4 QL1 ( .A({ A[3:0] }), .B({ B[3:0] }), .CI(CI), .CO(N_3), .S({ S[3:0] }) );

endmodule // radd16

`endif

`ifdef rgc8
`else
`define rgc8
module rgc8( CLK, CLR, D, Q );
input CLK, CLR;
 input [7:0] D;
 output [7:0] Q;

dffc QL8 ( .CLK(CLK), .CLR(CLR), .D(D[0]), .Q(Q[0]) );
dffc QL7 ( .CLK(CLK), .CLR(CLR), .D(D[1]), .Q(Q[1]) );
dffc QL6 ( .CLK(CLK), .CLR(CLR), .D(D[2]), .Q(Q[2]) );
dffc QL5 ( .CLK(CLK), .CLR(CLR), .D(D[3]), .Q(Q[3]) );
dffc QL4 ( .CLK(CLK), .CLR(CLR), .D(D[4]), .Q(Q[4]) );
dffc QL3 ( .CLK(CLK), .CLR(CLR), .D(D[5]), .Q(Q[5]) );
dffc QL2 ( .CLK(CLK), .CLR(CLR), .D(D[6]), .Q(Q[6]) );
dffc QL1 ( .CLK(CLK), .CLR(CLR), .D(D[7]), .Q(Q[7]) );

endmodule // rgc8

`endif

`ifdef rgc16
`else
`define rgc16
module rgc16( CLK, CLR, D, Q );
input CLK, CLR;
 input [15:0] D;
 output [15:0] Q;

dffc QL16 ( .CLK(CLK), .CLR(CLR), .D(D[15]), .Q(Q[15]) );
dffc QL15 ( .CLK(CLK), .CLR(CLR), .D(D[14]), .Q(Q[14]) );
dffc QL14 ( .CLK(CLK), .CLR(CLR), .D(D[13]), .Q(Q[13]) );
dffc QL13 ( .CLK(CLK), .CLR(CLR), .D(D[12]), .Q(Q[12]) );
dffc QL12 ( .CLK(CLK), .CLR(CLR), .D(D[11]), .Q(Q[11]) );
dffc QL11 ( .CLK(CLK), .CLR(CLR), .D(D[10]), .Q(Q[10]) );
dffc QL10 ( .CLK(CLK), .CLR(CLR), .D(D[9]), .Q(Q[9]) );
dffc QL9 ( .CLK(CLK), .CLR(CLR), .D(D[8]), .Q(Q[8]) );
dffc QL8 ( .CLK(CLK), .CLR(CLR), .D(D[7]), .Q(Q[7]) );
dffc QL7 ( .CLK(CLK), .CLR(CLR), .D(D[6]), .Q(Q[6]) );
dffc QL6 ( .CLK(CLK), .CLR(CLR), .D(D[5]), .Q(Q[5]) );
dffc QL5 ( .CLK(CLK), .CLR(CLR), .D(D[4]), .Q(Q[4]) );
dffc QL4 ( .CLK(CLK), .CLR(CLR), .D(D[3]), .Q(Q[3]) );
dffc QL3 ( .CLK(CLK), .CLR(CLR), .D(D[2]), .Q(Q[2]) );
dffc QL2 ( .CLK(CLK), .CLR(CLR), .D(D[1]), .Q(Q[1]) );
dffc QL1 ( .CLK(CLK), .CLR(CLR), .D(D[0]), .Q(Q[0]) );

endmodule // rgc16

`endif

`ifdef tffpc
`else
`define tffpc
module tffpc( CLK, CLR, PRE, Q, T );
input CLK, CLR, PRE;
output Q;
input T;
parameter ql_gate = `LOGIC;
wire N_1;
wire N_2;
supply1 VCC;
wire N_3;
supply0 GND;

frag_a I_3 ( .A1(VCC), .A2(GND), .A3(VCC), .A4(GND), .A5(VCC), .A6(GND), .AZ(N_1) );
frag_q I_2 ( .QC(CLK), .QD(N_3), .QR(CLR), .QS(PRE), .QZ(Q) );
frag_m I_1 ( .B1(VCC), .B2(GND), .C1(VCC), .C2(GND), .D1(Q), .D2(GND), .E1(VCC),
          .E2(Q), .NS(N_2), .OS(N_1), .OZ(N_3) );
frag_f QL1 ( .F1(T), .F2(GND), .F3(VCC), .F4(GND), .F5(VCC), .F6(GND), .FZ(N_2) );

endmodule // tffpc

`endif

`ifdef dffc
`else
`define dffc
module dffc( CLK, CLR, D, Q );
input CLK, CLR, D;
output Q;
parameter ql_gate = `LOGIC;
wire N_1;
wire N_2;
supply1 VCC;
wire N_3;
supply0 GND;

frag_f I_3 ( .F1(VCC), .F2(GND), .F3(VCC), .F4(GND), .F5(VCC), .F6(GND), .FZ(N_1) );
frag_a I_2 ( .A1(VCC), .A2(GND), .A3(VCC), .A4(GND), .A5(VCC), .A6(GND), .AZ(N_2) );
frag_q I_1 ( .QC(CLK), .QD(N_3), .QR(CLR), .QS(GND), .QZ(Q) );
frag_m QL1 ( .B1(VCC), .B2(GND), .C1(VCC), .C2(GND), .D1(VCC), .D2(GND), .E1(D),
          .E2(GND), .NS(N_1), .OS(N_2), .OZ(N_3) );

endmodule // dffc

`endif

`ifdef fadd1
`else
`define fadd1
module fadd1( A, B, CI, CO, S );
input A, B, CI;
output CO, S;

maj3i0 QL2 ( .A(A), .B(B), .C(CI), .Q(CO) );
xor3i0 QL1 ( .A(CI), .B(B), .C(A), .Q(S) );

endmodule // fadd1

`endif

`ifdef and2i0
`else
`define and2i0
module and2i0( A, B, Q );
input A, B;
output Q;
parameter ql_gate = `LOGIC;
supply1 VCC;
supply0 GND;

frag_a QL1 ( .A1(A), .A2(GND), .A3(B), .A4(GND), .A5(VCC), .A6(GND), .AZ(Q) );

endmodule // and2i0

`endif

`ifdef or2i0
`else
`define or2i0
module or2i0( A, B, Q );
input A, B;
output Q;
parameter ql_gate = `LOGIC;
wire N_1;
supply0 GND;
wire N_2;
supply1 VCC;

frag_f I_2 ( .F1(VCC), .F2(A), .F3(VCC), .F4(B), .F5(VCC), .F6(GND), .FZ(N_1) );
frag_m I_1 ( .B1(VCC), .B2(GND), .C1(VCC), .C2(GND), .D1(VCC), .D2(GND), .E1(GND),
          .E2(VCC), .NS(N_1), .NZ(Q), .OS(N_2) );
frag_a QL3 ( .A1(VCC), .A2(GND), .A3(VCC), .A4(GND), .A5(VCC), .A6(GND), .AZ(N_2) );

endmodule // or2i0

`endif

`ifdef mux2x0
`else
`define mux2x0
module mux2x0( A, B, Q, S );
input A, B;
output Q;
input S;
parameter ql_gate = `LOGIC;
wire N_1;
supply1 VCC;
supply0 GND;
wire N_2;

frag_f I_2 ( .F1(S), .F2(GND), .F3(VCC), .F4(GND), .F5(VCC), .F6(GND), .FZ(N_1) );
frag_m I_1 ( .B1(VCC), .B2(GND), .C1(VCC), .C2(GND), .D1(A), .D2(GND), .E1(B),
          .E2(GND), .NS(N_1), .NZ(Q), .OS(N_2) );
frag_a QL3 ( .A1(VCC), .A2(GND), .A3(VCC), .A4(GND), .A5(VCC), .A6(GND), .AZ(N_2) );

endmodule // mux2x0

`endif

`ifdef ckcell
`else
`define ckcell
module ckcell( IC, IN, IP, IZ );
output IC, IN;
input IP;
output IZ;
parameter ql_frag = 1;
 assign #1 IN = ~IP;
 assign #1 IZ = IP;
 assign #1 IC = IP;

endmodule // ckcell

`endif

`ifdef incell
`else
`define incell
module incell( IN, IP, IZ );
output IN;
input IP;
output IZ;
parameter ql_frag = 1;
 assign #1 IN = ~IP;
 assign #1 IZ = IP;

endmodule // incell

`endif

`ifdef frag_m
`else
`define frag_m
module frag_m( B1, B2, C1, C2, D1, D2, E1, E2, NS, NZ, OS, OZ );
input B1, B2, C1, C2, D1, D2, E1, E2, NS;
output NZ;
input OS;
output OZ;
parameter ql_frag = 1;
 assign #1 NZ = NS ? (E1 & ~E2):(D1 & ~D2);
 assign #1 OZ = OS ? NZ:(NS ? (C1 & ~C2):(B1 & ~B2));

endmodule // frag_m

`endif

`ifdef frag_q
`else
`define frag_q
module frag_q( QC, QD, QR, QS, QZ );
input QC, QD, QR, QS;
output QZ;
parameter ql_frag = 1;
 reg QZ;
`ifdef synthesis
 always @ (posedge QC or posedge QR or posedge QS) 
     if (QR)
        #1 QZ = 1'b0;
     else if (QS)
        #1 QZ = 1'b1;
     else #1 QZ = QD;
`else
  always @ (QR or QS) begin
      if (QR)
         #1 assign QZ = 1'b0;
      else if (QS)
         #1 assign QZ = 1'b1;
      else
         #1 deassign QZ;
  end
  always @ (posedge QC)
         QZ = #1 QD;
  initial begin
    #1;
    if (QR)
         #1 assign QZ = 1'b0;
    else if (QS)
         #1 assign QZ = 1'b1;
  end
 `endif

endmodule // frag_q

`endif

`ifdef frag_f
`else
`define frag_f
module frag_f( F1, F2, F3, F4, F5, F6, FZ );
input F1, F2, F3, F4, F5, F6;
output FZ;
parameter ql_frag = 1;
 assign #1 FZ = F1 & ~F2 & F3 & ~F4 & F5 & ~F6;

endmodule // frag_f

`endif

`ifdef rgec16
`else
`define rgec16
module rgec16( CLK, CLR, D, EN, Q );
input CLK, CLR;
 input [15:0] D;
input EN;
 output [15:0] Q;
supply0 GND;

dffepc QL16 ( .CLK(CLK), .CLR(CLR), .D(D[12]), .EN(EN), .PRE(GND), .Q(Q[12]) );
dffepc QL15 ( .CLK(CLK), .CLR(CLR), .D(D[13]), .EN(EN), .PRE(GND), .Q(Q[13]) );
dffepc QL14 ( .CLK(CLK), .CLR(CLR), .D(D[14]), .EN(EN), .PRE(GND), .Q(Q[14]) );
dffepc QL13 ( .CLK(CLK), .CLR(CLR), .D(D[15]), .EN(EN), .PRE(GND), .Q(Q[15]) );
dffepc QL12 ( .CLK(CLK), .CLR(CLR), .D(D[8]), .EN(EN), .PRE(GND), .Q(Q[8]) );
dffepc QL11 ( .CLK(CLK), .CLR(CLR), .D(D[9]), .EN(EN), .PRE(GND), .Q(Q[9]) );
dffepc QL10 ( .CLK(CLK), .CLR(CLR), .D(D[10]), .EN(EN), .PRE(GND), .Q(Q[10]) );
dffepc QL9 ( .CLK(CLK), .CLR(CLR), .D(D[11]), .EN(EN), .PRE(GND), .Q(Q[11]) );
dffepc QL8 ( .CLK(CLK), .CLR(CLR), .D(D[4]), .EN(EN), .PRE(GND), .Q(Q[4]) );
dffepc QL7 ( .CLK(CLK), .CLR(CLR), .D(D[5]), .EN(EN), .PRE(GND), .Q(Q[5]) );
dffepc QL6 ( .CLK(CLK), .CLR(CLR), .D(D[6]), .EN(EN), .PRE(GND), .Q(Q[6]) );
dffepc QL5 ( .CLK(CLK), .CLR(CLR), .D(D[7]), .EN(EN), .PRE(GND), .Q(Q[7]) );
dffepc QL4 ( .CLK(CLK), .CLR(CLR), .D(D[0]), .EN(EN), .PRE(GND), .Q(Q[0]) );
dffepc QL3 ( .CLK(CLK), .CLR(CLR), .D(D[1]), .EN(EN), .PRE(GND), .Q(Q[1]) );
dffepc QL2 ( .CLK(CLK), .CLR(CLR), .D(D[2]), .EN(EN), .PRE(GND), .Q(Q[2]) );
dffepc QL1 ( .CLK(CLK), .CLR(CLR), .D(D[3]), .EN(EN), .PRE(GND), .Q(Q[3]) );

endmodule // rgec16

`endif

`ifdef and4i0
`else
`define and4i0
module and4i0( A, B, C, D, Q );
input A, B, C, D;
output Q;
parameter ql_gate = `LOGIC;
wire N_1;
supply1 VCC;
supply0 GND;
wire N_2;

frag_f I_2 ( .F1(A), .F2(GND), .F3(B), .F4(GND), .F5(C), .F6(GND), .FZ(N_1) );
frag_m I_1 ( .B1(VCC), .B2(GND), .C1(VCC), .C2(GND), .D1(GND), .D2(VCC), .E1(D),
          .E2(GND), .NS(N_1), .NZ(Q), .OS(N_2) );
frag_a QL3 ( .A1(VCC), .A2(GND), .A3(VCC), .A4(GND), .A5(VCC), .A6(GND), .AZ(N_2) );

endmodule // and4i0

`endif

`ifdef dffepc
`else
`define dffepc
module dffepc( CLK, CLR, D, EN, PRE, Q );
input CLK, CLR, D, EN, PRE;
output Q;
parameter ql_gate = `LOGIC;
wire N_1;
wire N_2;
wire N_3;
supply1 VCC;
supply0 GND;

frag_a I_3 ( .A1(VCC), .A2(GND), .A3(VCC), .A4(GND), .A5(VCC), .A6(GND), .AZ(N_1) );
frag_m I_2 ( .B1(VCC), .B2(GND), .C1(VCC), .C2(GND), .D1(Q), .D2(GND), .E1(D),
          .E2(GND), .NS(N_3), .OS(N_1), .OZ(N_2) );
frag_q I_1 ( .QC(CLK), .QD(N_2), .QR(CLR), .QS(PRE), .QZ(Q) );
frag_f QL1 ( .F1(EN), .F2(GND), .F3(VCC), .F4(GND), .F5(VCC), .F6(GND), .FZ(N_3) );

endmodule // dffepc

`endif

`ifdef nand5i1
`else
`define nand5i1
module nand5i1( A, B, C, D, E, Q );
input A, B, C, D, E;
output Q;
parameter ql_gate = `LOGIC;
wire N_1;
supply1 VCC;
supply0 GND;
wire N_2;

frag_f I_2 ( .F1(A), .F2(GND), .F3(B), .F4(E), .F5(C), .F6(GND), .FZ(N_1) );
frag_m I_1 ( .B1(VCC), .B2(GND), .C1(VCC), .C2(GND), .D1(VCC), .D2(GND), .E1(VCC),
          .E2(D), .NS(N_1), .NZ(Q), .OS(N_2) );
frag_a QL3 ( .A1(VCC), .A2(GND), .A3(VCC), .A4(GND), .A5(VCC), .A6(GND), .AZ(N_2) );

endmodule // nand5i1

`endif

`ifdef nand4i0
`else
`define nand4i0
module nand4i0( A, B, C, D, Q );
input A, B, C, D;
output Q;
parameter ql_gate = `LOGIC;
wire N_1;
supply1 VCC;
supply0 GND;
wire N_2;

frag_f I_2 ( .F1(A), .F2(GND), .F3(B), .F4(GND), .F5(C), .F6(GND), .FZ(N_1) );
frag_m I_1 ( .B1(VCC), .B2(GND), .C1(VCC), .C2(GND), .D1(VCC), .D2(GND), .E1(VCC),
          .E2(D), .NS(N_1), .NZ(Q), .OS(N_2) );
frag_a QL3 ( .A1(VCC), .A2(GND), .A3(VCC), .A4(GND), .A5(VCC), .A6(GND), .AZ(N_2) );

endmodule // nand4i0

`endif

`ifdef upbit
`else
`define upbit
module upbit( CLK, CLR, D, ENG, ENP, ENT, LOAD, Q, Q0, Q1, Q2 );
input CLK, CLR, D, ENG, ENP, ENT, LOAD;
output Q;
input Q0, Q1, Q2;
parameter ql_gate = `LOGIC;
wire N_1;
wire N_2;
wire N_3;
supply0 GND;
supply1 VCC;

frag_q I_3 ( .QC(CLK), .QD(N_1), .QR(CLR), .QS(GND), .QZ(Q) );
frag_m I_2 ( .B1(Q), .B2(GND), .C1(VCC), .C2(Q), .D1(D), .D2(GND), .E1(D), .E2(GND),
          .NS(N_2), .OS(N_3), .OZ(N_1) );
frag_f I_1 ( .F1(Q0), .F2(ENP), .F3(Q1), .F4(ENT), .F5(Q2), .F6(ENG), .FZ(N_2) );
frag_a QL1 ( .A1(LOAD), .A2(GND), .A3(VCC), .A4(GND), .A5(VCC), .A6(GND), .AZ(N_3) );

endmodule // upbit

`endif

`ifdef radd4
`else
`define radd4
module radd4( A, B, CI, CO, S );
 input [3:0] A;
 input [3:0] B;
input CI;
output CO;
 output [3:0] S;
wire N_1;
wire N_2;
wire N_3;

fadd1 QL1 ( .A(A[0]), .B(B[0]), .CI(CI), .CO(N_1), .S(S[0]) );
fadd1 QL2 ( .A(A[1]), .B(B[1]), .CI(N_1), .CO(N_2), .S(S[1]) );
fadd1 QL3 ( .A(A[2]), .B(B[2]), .CI(N_2), .CO(N_3), .S(S[2]) );
fadd1 QL4 ( .A(A[3]), .B(B[3]), .CI(N_3), .CO(CO), .S(S[3]) );

endmodule // radd4

`endif

`ifdef maj3i0
`else
`define maj3i0
module maj3i0( A, B, C, Q );
input A, B, C;
output Q;
parameter ql_gate = `LOGIC;
supply0 GND;
supply1 VCC;
wire N_1;
wire N_2;

frag_m I_2 ( .B1(GND), .B2(VCC), .C1(C), .C2(GND), .D1(C), .D2(GND), .E1(VCC),
          .E2(GND), .NS(N_2), .OS(N_1), .OZ(Q) );
frag_f I_1 ( .F1(B), .F2(GND), .F3(VCC), .F4(GND), .F5(VCC), .F6(GND), .FZ(N_2) );
frag_a QL1 ( .A1(A), .A2(GND), .A3(VCC), .A4(GND), .A5(VCC), .A6(GND), .AZ(N_1) );

endmodule // maj3i0

`endif

`ifdef xor3i0
`else
`define xor3i0
module xor3i0( A, B, C, Q );
input A, B, C;
output Q;
parameter ql_gate = `LOGIC;
supply0 GND;
supply1 VCC;
wire N_1;
wire N_2;

frag_m I_2 ( .B1(C), .B2(GND), .C1(VCC), .C2(C), .D1(VCC), .D2(C), .E1(C), .E2(GND),
          .NS(N_2), .OS(N_1), .OZ(Q) );
frag_f I_1 ( .F1(B), .F2(GND), .F3(VCC), .F4(GND), .F5(VCC), .F6(GND), .FZ(N_2) );
frag_a QL1 ( .A1(A), .A2(GND), .A3(VCC), .A4(GND), .A5(VCC), .A6(GND), .AZ(N_1) );

endmodule // xor3i0

`endif
